///////////////////////////////////////////////////////////////////
//Mehrfach-Rotationen aus Kapitel Räumliche Formen
/////////////////////////////////////////////////////////////////

float alpha = 0;
float beta = 0;
float gamma = 0;
float delta = 0;

void setup() {
  size(900, 900, P3D);  // oder size(900, 900, OPENGL);
  frameRate(50);
  sphereDetail(10);
}


void draw_Arm2() {
  fill(100, 0, 100); 
  noStroke(); 
  sphere(15);
  for (float k = 0; k < TWO_PI; k += PI) { //2 Speichen
    pushMatrix();
    rotateY(k+gamma);       
    strokeWeight(2);
    stroke(100, 0, 255);
    line(0, 5, 0, 55, 0, 0); 
    translate(55, 0); 
    stroke(100, 0, 255); 
    sphere(10);
    popMatrix();
  }
}

void draw_Arm() {
  fill(255, 0, 100); 
  noStroke(); 
  sphere(20);
  for (float j = 0; j < TWO_PI; j += 2*PI/3) { //3 Speichen
    pushMatrix();
    rotateX(-j-beta);   
    strokeWeight(4);
    stroke(150, 0, 150); 
    line(0, 8, 0, 0, 125, 0);   //rot
    translate(0, 125);
    draw_Arm2();
    popMatrix();
  }
}

void draw() {
  background(255);
  stroke(0);
  translate(width/2, height/2);
  // das Ganze noch um die y-Achse rotieren lassen... 
  rotateY(delta);
  fill(100, 0, 255);
  noStroke();   
  sphere(30);                   
  for (float i = 0; i < TWO_PI; i +=PI/3 ) { //6 Speichen
    pushMatrix(); 
    rotate(alpha + i);   
    strokeWeight(6);
    stroke(150, 0, 150);
    line(15, 0, 0, 300, 0, 0);   //magenta
    translate(300, 0);
    draw_Arm();
    popMatrix();
  }
  //Hiermit kann man die Drehfrequenz bestimmen.
  //Ja größer, desto schneller die Drehung
  alpha += 0.01;
  beta  += 0.02;
  gamma += 0.05;
  delta += 0.01;
}

void keyPressed() {
  if (key == 's') save("tmp.png");
}